stages:
  - build
  - release

image: docker:stable
services:
  - docker:dind

before_script:
  # GitLabレジストリへのログイン
  - docker login -u "${CI_REGISTRY_USER}" -p "${CI_REGISTRY_PASSWORD}" "${CI_REGISTRY}"

after_script:
  # GitLabレジストリからのログアウト
  - docker logout "${CI_REGISTRY}"

  # Dockerコンテナイメージのビルド
build_container_image:
  stage: build
  script:
    # コンテナイメージをビルドしてユニークなタグ名でレジストリに登録する
    - docker image build -t "${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}-${CI_PIPELINE_ID}" ./container
    - docker image push "${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}-${CI_PIPELINE_ID}"

# Docker Hubへのコンテナイメージのリリース
release_container_image:
  stage: release
  # タグを作成した時だけ実行
  only:
    - tags
  script:
    # コンテナイメージを一旦取得して正式なタグ名をつけてレジストリに登録する
    - docker image pull "${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}-${CI_PIPELINE_ID}"
    - docker image tag "${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}-${CI_PIPELINE_ID}" "${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG}"
    - docker image push "${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG}"
